(game-module "bellum"
    (title "Bellum Aeternum")
    (blurb "This is a world conquest game. Command and control has a strong impact on its play. A large variety of unit types are available. (Developed by Eric McDonald)")
    (base-game true)
    (instructions (
        "Keep an eye on the command and control levels for your units."
        "You will probably need to build field HQ's, capital ships, and bases to continue exerting your will upon units as you expand outwards and engage opponents."
        "Also, bases and sea bases are a relatively cheap way of increasing your production capacity for planes, ships, and special units." 
        "If you have not already done so, it is recommended that you read the Xconq game manual and the Bellum Aeternum unit and material info, so that you can get the most out of the game."
        "(The Bellum Aeternum game modules were developed by Eric McDonald, mcdonald at phy dot cmich dot edu.)"
    ))
    (notes (
        "The philosophy of Bellum Aeternum is to simulate certain aspects of modern warfare, such as the importance of command and control and air supremacy, while providing fun game play."
        "However, supply lines are very liberal, and hence the game does not require the player to become a quartermaster or shipping clerk."
        ""
        "Still, one must pay attention to the amount of the abstract command and control supply (supply type 'c') that is getting to one's units."
        "Those units which produce command and control should be protected to prevent a drought of this supply."
        "If a side does not have enough command and control, it will start to become paralyzed."
        "Units will start running out of moves early and will not always be able to attack."
        ""
        "Towns are the most prolific type of city unit at the start of a game."
        "Although they are many in quantity, they lack the ability to produce sea and air units."
        "One may still produce those units in larger city units."
        "They may also be produced in naval and air bases."
        "But because towns are initially the most numerous producer type, there is a definite bias towards the production of ground forces."
        "Air units, however, are extremely mobile and things such as dive bombers are incredibly lethal."
        "The wise player will probably want to gain air supremacy, and this will require a concerted effort on his/her part."
        ""
        "Other things of note are germinators, engineers, and mines."
        "Germinators collect settlers, and once they have a sufficient quantity, they will be able to build new towns, or a special type of military industrial center called a 'grand citadel'."
        "Engineers can lay mine fields and build forts and both types of bases."
        "Both minefields on land and flotillas of mines at sea are available."
        ""
        "Bugs, criticisms, and suggestions to mcdonald at phy dot cmich dot edu."
        "Have fun."
    ))
    (version "1.0.20 Beta")
    (variants
	("World Size" world-size 
"Height and width of playing area compared to total circumference of the world."
	    (100 100 1900)
        )
        ("Mapped World" world-seen
	    "All terrain of the world starts out mapped."
	    false
        )
        ("Total Visibility" see-all
	    "Everything is seen all the time."
	    false
        )
        ("Sequential Play" sequential
	    "Player turns proceed in an order instead of all at once."
	    true
        )
        ("Large Continents" large-continents 
	    "World is about 50% land."
	    true
	    (true
                (add sea alt-percentile-max 46)
	        (add coast alt-percentile-min 45)
	        (add coast alt-percentile-max 50)
	        (add (swamp desert forest plains) alt-percentile-min 50)
;	        (add lake alt-percentile-min 52)
                (add base start-with 2)
                (add shipyard start-with 1)
                (add mechinf start-with 2)
                (add marines start-with 1)
                (add aaa start-with 0)
                (add transports start-with 1)
                (add patrol-ship start-with 2)
                (add destroyer start-with 0)
                (add frigate start-with 1)
                (add ecarrier start-with 0)
                (add fighters start-with 3)
                (add efighters start-with 0)
                (add dive-bombers start-with 1)
                (add torp-bombers start-with 0)
                (add bombers start-with 0)
            )
        )
        ("Mostly Land" mostly-land
	    "World is about 70% land."
	    (true
                (add sea alt-percentile-max 28)
	        (add coast alt-percentile-min 27)
                (add coast alt-percentile-max 30)
                (add (swamp desert forest plains) alt-percentile-min 30)
;               (add lake alt-percentile-min 32)
                (add base start-with 3)
                (add shipyard start-with 0)
                (add mechinf start-with 3)
                (add marines start-with 0)
                (add aaa start-with 1)
                (add transports start-with 0)
                (add patrol-ship start-with 0)
                (add destroyer start-with 0)
                (add frigate start-with 0)
                (add ecarrier start-with 0)
                (add fighters start-with 4)
                (add efighters start-with 1)
                (add dive-bombers start-with 2)
                (add torp-bombers start-with 0)
                (add bombers start-with 1)
            )
        )
        ("Teeming with Life" dagobah
	    "World is full of swamp and forests."
            false
	    (true
                (add swamp wet-percentile-min 50)
                (add forest wet-percentile-min 20)
                (add plains wet-percentile-min 0)
                (add plains wet-percentile-max 40)
                (add desert wet-percentile-max 0)
                (add swamp alt-percentile-max 85)
                (add infantry start-with 3)
                (add armor start-with 0)
            )
        )
        ("From Scratch" from-scratch 
	    "No starting units except Capitol."
	    (true
                (add u* start-with 0)
                (add capitol start-with 1)
                (set country-radius-max 1)
                (set growth-stop-chance 100)
            )
        )
        ("All Humans" all-humans
            "No computer players. Only humans. Special rules in effect."
            (true
                (table wrecks-on add
                    (battleship coast true)
                    (lcarrier coast true)
                    (carrier coast true)
                )
#|
                (table can-enter-independent add
                    (mobile-u* city-u* false)
                )
|#
            )
        )
        ("Stubborn Sides" stubborn-sides
            "Side continues to play after its capitol is captured or destroyed."
            true
            (true
                (add (citadel base shipyard) can-be-self true)
                (add (field-hq ccruiser battleship carrier) can-be-self true)
                (add (capitol citadel base shipyard) self-resurrects true)
                (add (field-hq ccruiser battleship carrier) 
                    self-resurrects true)
            )
        )
    )	
)

;; Included Modules
; uu-bellum includes u-bellum includes t-bellum
(include "uu-bellum")

;; General Game Setup

(set sides-min 2)
(set sides-wanted 2)

(set advantage-min 1)
(set advantage-default 1)

(scorekeeper
    (title "Score")
;   (known-to ())
    (do last-side-wins)
)
;(set scorefile-name "bellum")
(table lost-surrender-chance add
    (u* u* 10000)
    (capitol u* 0)
)

(set self-required true)

(set ai-may-resign true)
;(set units-may-go-into-reserve false)

; NOTE: Capitols are self-units and default to 1 per side
(add metropolis start-with 0)
(add citadel start-with 0)
(add city start-with 1)
(add town start-with 3)
(add base start-with 1)
(add shipyard start-with 2)
(add ruins start-with 0)
(add infantry start-with 1)
(add mechinf start-with 0)
(add armor start-with 1)
(add marines start-with 2)
(add aaa start-with 0)
(add paratroops start-with 1)
(add germinator start-with 1)
(add engineers start-with 1)
(add transports start-with 2)
(add patrol-ship start-with 2)
(add destroyer start-with 2)
(add frigate start-with 1)
(add ecarrier start-with 1)
(add cargo-planes start-with 1)
(add fighters start-with 2)
(add efighters start-with 0)
(add dive-bombers start-with 0)
(add torp-bombers start-with 1)
(add bombers start-with 0)

(add capitol country-units-max 1)
(add metropolis country-units-max 0)
(add citadel country-units-max 0)
(add city country-units-max 1)
(add town country-units-max 3)
(add ruins country-units-max 0)

(doctrine rrr
    (construction-run (u* 1))
    (resupply-percent 60)
    (rearm-percent 20)
    (repair-percent 20)
)
(doctrine city-unit-doctrine
    (construction-run
        ((town citadel base shipyard) 1)
	((infantry mechinf) 5)
	((cavalry armor marines paratroops artillery aaa engineers) 3)
	((field-hq germinator) 1)
	(air-u* 3)
        (spy-planes 1)
    )
    (resupply-percent 0)
    (rearm-percent 0)
    (repair-percent 0)
)
(doctrine base-doctrine
    (construction-run
	((infantry mechinf) 5)
	((cavalry armor marines paratroops artillery aaa) 3)
	((field-hq) 1)
	(air-u* 3)
        (spy-planes 1)
    )
    (resupply-percent 0)
    (rearm-percent 0)
    (repair-percent 0)
)
(doctrine shipyard-doctrine
    (construction-run
	((transports torp-boats patrol-ship) 5)
	((marines destroyer frigate cruiser ecarrier) 3)
	((ccruiser battleship lcarrier carrier submarine) 1)
        ((fighters torp-bombers dive-bombers) 3)
    )
    (resupply-percent 0)
    (rearm-percent 0)
    (repair-percent 0)
)
(doctrine land-unit-doctrine
    (resupply-percent 50)
    (rearm-percent 20)
    (repair-percent 20)
)
(doctrine engineers-doctrine
    (construction-run
        ((forts base shipyard landmines) 1)
    )
    (resupply-percent 90)
    (rearm-percent 90)
    (repair-percent 50)
)
(doctrine germinator-doctrine
    (construction-run
        ((town citadel) 1)
    )
    (resupply-percent 90)
    (rearm-percent 90)
    (repair-percent 50)
)
(doctrine sea-unit-doctrine
    (construction-run
        (seamines 1)
    )
    (resupply-percent 50)
    (rearm-percent 20)
    (repair-percent 20)
)
(doctrine air-unit-doctrine
    (resupply-percent 65)
    (rearm-percent 30)
    (repair-percent 20)
)
(side-defaults
    (default-doctrine rrr)
    (doctrines
        (city-u* city-unit-doctrine)
        (base base-doctrine)
        (shipyard shipyard-doctrine)
	(land-u* land-unit-doctrine)
        (engineers engineers-doctrine)
        (germinator germinator-doctrine)
        (sea-u* sea-unit-doctrine)
        (air-u* air-unit-doctrine)
    )
#|
    (treasury
    )
|#
)

(set feature-types '(peaks islands lakes bays seas continents 
	(desert 10) (forest 10) (mountains 5)))
(set feature-namers '(
	(islands generic-island-names)
	(lakes generic-lake-names)
	(bays generic-bay-names)
	(seas generic-sea-names)
	(continents generic-continent-names)
	(desert generic-desert-names)
	(forest generic-forest-names)
	(mountains generic-mountain-names)
))
(set default-namer "generic-names")

(set country-radius-max 15)
(set growth-stop-chance 20)
(set country-separation-min 20)

;(set see-terrain-always false)

;; Map Synthesis and Game Initialization

(set synthesis-methods '(
    make-fractal-percentile-terrain
    make-countries
    make-independent-units
    make-roads
    make-rivers
    make-initial-materials
    name-geographical-features
    name-units-randomly
))

#|
  Thanks to Stan Shebs for creating the Xconq framework so many years ago, 
and working to maintain and improve it. This game would still just be a 
remote dream in my head if it was not for Xconq.
|#

#|
  "Bellum Aeternum" is Latin for "War Eternal".
|#

#|
  "Numquam periculum sine periculo vincitur."
    (Publilius Syrus, c. 100 B.C.E.)
  "Never is danger conquered without danger."
|#

;;; Bellum Aeternum Dedication ;;;
#|
  This set of game modules is respectfully dedicated to the armed forces 
of the United States of America. Never has such a technologically and 
logistically advanced military ever been seen in this world. Nor one 
so well-equipped or so well-educated. Nor one so humane or so 
compassionate.
  Whether or not one agrees with the policies of the republic (or empire) 
that sends these excellent forces on missions and campaigns, one must 
acknowledge that, in this day and age, they have become the greatest 
fighting power ever to be seen on this planet.
  If historians can be unbiased and diligent in their duties, then these 
awesome forces must have an enduring and prominent place in the 
chronicles of the world's conflicts. The legions of Rome, the mounted 
archers of Genghis, Khan of the Mongols, and the navies of the British 
and Dutch empires pale before the swift, organized, lethal might of the 
Eagle.
    Veni, vidi, vici,
        Eric McDonald (2003/08/26)
|#
