(game-module "t-bellum"
    (blurb "Terrain and materials for the Bellum Aeternum games.")
)

;; World and Game Area Parameters

(area 
    (cell-width 20000) ; Cell width is in elevation units. 
)

;; Material Types

(material-type cnc
    (char "c")
    (name "c")
    (help "Command and Control. Somewhat abstract quantity.")
)

(material-type fuel1
    (char "f")
    (name "f1")
    (help "Fuel. Combusted by engines to perform work.")
)

(material-type fuel2
    (char "g")
    (name "f2")
    (help "Fuel. Combusted by engines to perform work.")
)

(material-type recruits
    (char "r")
    (name "r")
    (help "Recruits. Young people who are willing to die for your cause.")
    (people 100)
;    (treasury true)
)

(material-type pilots
    (char "v")
    (name "v")
    (help "Pilots. Trained military aviators.")
    (people 20)
;    (treasury true)
)

(material-type settlers
    (char "h")
    (name "h")
    (help "Settlers. The foundation for new towns.")
    (people 100)
;    (treasury true)
)

(material-type equipment
    (char "e")
    (name "e")
    (help "Equipment. Guns, radar, radios, etc....")
)

(material-type vehicles
    (char "m")
    (name "m")
    (help "Vehicles. Trucks, tanks, bulldozers, planes, etc....")
)

(material-type supplies
    (char "s")
    (name "s")
    (help "Supplies. Food and drink, oil, grease, parts, etc....")
)

(material-type city-points
    (char "p")
    (name "p")
    (help "City Points. Abstract measure of population and development.")
)

;; Terrain Types

(terrain-type sea
    (char ".")
    (image-name "sea")
    (help "deep salt water")
    (liquid true)
    (wet-percentile-max 100)
    (alt-percentile-max 71)
    (river-chance 0)
    (elevation-min 0)
    (elevation-max 3)
    (country-terrain-min 1)
    (country-growth-chance 100)
    (country-takeover-chance 50)
)

(terrain-type |coastal waters|
    (char ".")
    (image-name "shallows")
    (help "salt water on a continental shelf")
    (liquid true)
    (wet-percentile-max 100)
    (alt-percentile-min 70)
    (alt-percentile-max 75)
    (river-chance 0)
    (elevation-min 0)
    (elevation-max 3)
    (country-terrain-min 1)
    (country-growth-chance 100)
    (country-takeover-chance 50)
)
(define coast |coastal waters|)

(terrain-type lake
    (char ".")
    (image-name "shallows")
    (help "freshwater lake")
    (liquid true)
    (wet-percentile-min 100)
    (wet-percentile-max 100)
    (alt-percentile-min 100)
    (alt-percentile-max 100)
    (river-chance 5000)
    (elevation-min 200)
    (elevation-max 2000)
    (country-growth-chance 100)
    (country-takeover-chance 50)
)

(terrain-type swamp
    (char ",")
    (image-name "swamp")
    (help "damp, muddy regions")
    (wet-percentile-min 90)
    (wet-percentile-max 100)
    (alt-percentile-min 76)
    (alt-percentile-max 77)
    (river-chance 3000)
    (elevation-min 4)
    (elevation-max 2000)
    (country-growth-chance 20)
    (country-takeover-chance 10)
)

(terrain-type forest
    (char "%")
    (image-name "forest")
    (help "thick forest or jungle")
    (wet-percentile-min 60)
    (wet-percentile-max 100)
    (alt-percentile-min 72)
    (alt-percentile-max 95)
    (river-chance 1000)
    (elevation-min 3)
    (elevation-max 2000)
    (country-growth-chance 40)
    (country-takeover-chance 20)
)

(terrain-type plains
    (char " ")
    (image-name "plains")
    (help "open flat or rolling grasslands")
    (wet-percentile-min 15)
    (wet-percentile-max 90)
    (alt-percentile-min 72)
    (alt-percentile-max 95)
    (river-chance 500)
    (elevation-min 3)
    (elevation-max 2000)
    (country-terrain-min 5)
    (country-growth-chance 100)
    (country-takeover-chance 50)
)

(terrain-type mountains
    (char "^")
    (image-name "mountains")
    (help "mountains and large hills")
    (wet-percentile-min 0)
    (wet-percentile-max 100)
    (alt-percentile-min 90)
    (alt-percentile-max 99)
    (river-chance 3000)
    (elevation-min 1500)
    (elevation-max 4700)
    (country-growth-chance 40)
    (country-takeover-chance 20)
)

(terrain-type desert
    (char "~")
    (image-name "desert")
    (help "burning desert or barren tundra")
    (wet-percentile-min 0)
    (wet-percentile-max 20)
    (alt-percentile-min 72)
    (alt-percentile-max 95)
    (river-chance 0)
    (elevation-min 3)
    (elevation-max 2000)
    (country-growth-chance 50)
    (country-takeover-chance 25)
)

(terrain-type glaciers
    (char "_")
    (image-name "ice")
    (help "slippery frozen terrain")
    (wet-percentile-min 0)
    (wet-percentile-max 100)
    (alt-percentile-min 99)
    (alt-percentile-max 100)
    (river-chance 10000)
    (elevation-min 4000)
    (elevation-max 5000)
    (country-growth-chance 5)
    (country-takeover-chance 2)
)
(define ice glaciers)

(terrain-type barrier
    (char "\"")
    (image-name "black")
    (help "impenetrable barrier")
    (river-chance 0)
    (country-growth-chance 0)
    (country-takeover-chance 0)
)
(set edge-terrain barrier)

(terrain-type river
    (char ".")
    (image-name "river")
    (help "flows across pieces of land terrain")
    (subtype border)
    (subtype-x river-x)
)
(set river-sink-terrain lake)

(terrain-type road
    (char "=")
    (image-name "road")
    (help "runs between towns and cities")
    (subtype connection)
    (subtype-x road-x)
)

(define water-t* (sea coast lake))
(define shallows (coast lake))
(define land-t* (swamp plains forest desert mountains glaciers))
(define cell-t* (water-t* land-t*))

(add t* capacity 16)
;(add road capacity 4)

; XCONQ BUG: Must define independent-people-chance for make-country
;  synthesis method otherwise get a FPE.
(add land-t* independent-people-chance 75)
(add land-t* country-people-chance 100)

(table road-into-chance
    ; Default: 0
    (land-t* land-t* 100)
    (land-t* glaciers 40)
    (land-t* barrier 0)
)

(table terrain-production
    ; Default: 0
)

; Defaults for fractal percentile generator.
(set alt-blob-density 10000)
(set alt-blob-size 300)
(set alt-blob-height 1000)
(set wet-blob-density 500)
(set wet-blob-size 20)
(set wet-blob-height 100)
(set alt-smoothing 4)
(set wet-smoothing 2)

(table terrain-density
    (t* t* 0)
    (coast plains 500)
    (sea coast 200)
    (glaciers mountains 8500)
)
(table adjacent-terrain-effect
    ; Default: non-terrain
    (desert swamp plains)
)
(table adjacent-terrain-effect
    ; Default: non-terrain
    (desert swamp plains)
)
