(game-module "uu-bellum"
    (blurb "Standard unit-unit interactions for the Bellum Aeternum games.")
)

(include "u-bellum")

(table road-chance
    ; Default: 0
    (capitol capitol 100)
    (metropolis (capitol metropolis) 100)
    (city (capitol metropolis city) 100)
    (town (city town ruins) (50 10 10))
    (ruins (city town ruins) (40 5 5))
)

(table occupant-max
    ; Default: -1
    (u* u* 0)
    ((capitol metropolis citadel city base) (append land-u* air-u*) 6)
    ((capitol metropolis citadel city shipyard) sea-u* 6)
    ((town forts shipyard) land-u* 2)
    (town (torp-boats patrol-ship destroyer frigate ecarrier) 1)
    (town air-u* 2)
    (forts air-u* 1)
    ((town forts) (cargo-planes bombers) 0)
    (ruins land-u* 1)
    (shipyard air-u* 3)
    (transports land-u* 6)
    (ecarrier (fighters dive-bombers torp-bombers) 1)
    (lcarrier (fighters dive-bombers torp-bombers) 3)
    (carrier (fighters dive-bombers torp-bombers) 6)
    (cargo-planes paratroops 1)
)

(table unit-capacity-x
    ; Default: 0
    (facility-u* air-u* 1)
    (ruins air-u* 0)
    ((town forts) (cargo-planes bombers) 0) 
)

(table unit-size-as-occupant
    ; Default: 1
    (u* u* 1000)
    (mobile-u* facility-u* 1)
    (sea-u* (ruins forts base) 1000)
    (land-u* transports 1)
    ((fighters dive-bombers torp-bombers) carrier-u* 1)
    (paratroops cargo-planes 2)
)

(table acp-to-enter-unit
    ; Default: 1
)

(table mp-to-enter-unit
    ; Default: 0
    (u* u* 1000)
    (mobile-u* facility-u* 1)
    (land-u* facility-u* 0)
    (air-u* ruins 0)
    (land-u* forts 1)
    (land-u* shipyard 1000)
    ((marines engineers) shipyard 0)
    (sea-u* shipyard 1)
    (land-u* transports 1)
    (air-u* carrier-u* 1)
    (land-u* cargo-planes 1)
)

(table mp-to-leave-unit
    ; Default: 0
    (land-u* transports 1)
    (land-u* cargo-planes 1)
    (sea-u* facility-u* 1)
)

(table can-enter-independent
    ; Default: false
#|
    ; NOTE: See all-humans variant.
    ((artillery aaa germinator engineers) city-u* true)
    (sea-u* city-u* true)
    (air-u* city-u* true)
    (u* ruins false)
|#
)

(table ferry-on-entry
    ; Default: over-border
    (facility-u* u* over-own)
    (transports u* over-own)
    (carrier-u* u* over-own)
    (cargo-planes u* over-own)
)

(table ferry-on-departure
    ; Default: over-border
    (facility-u* u* over-own)
    (transports u* over-own)
    (carrier-u* u* over-own)
    (cargo-planes u* over-own)
)

(table zoc-range
    ; Default: 0
    ((ruins town) u* -1)
    (land-u* air-u* -1)
    (aaa air-u* 0)
    (shipwreck u* -1)
    (shipwreck sea-u* 0)
    (destroyer submarine 0) ; ASW specialists
    (sea-u* air-u* -1)
    ((destroyer frigate) air-u* 0) ; Picket ships
    (submarine u* -1)
    (air-u* u* -1)
    ((fighters efighters) air-u* 0)
    (mine-u* air-u* -1)
)

(table acp-to-create
    ; Default: 0
    (capitol (append town citadel base shipyard land-u* sea-u* air-u*) 3)
    (capitol (field-hq germinator) 6)
    (metropolis (append land-u* sea-u*) 2)
    (metropolis (append town base shipyard air-u*) 4)
    (metropolis germinator 8)
    (metropolis (field-hq spy-planes) 0)
    (citadel (append base shipyard land-u* sea-u* air-u*) 2)
    (citadel field-hq 4)
    (citadel germinator 0)
    (city (append land-u* sea-u*) 2)
    (city (append base shipyard marines paratroops germinator 
            transports ccruiser battleship lcarrier carrier submarine air-u*) 4)
    (city (paratroops field-hq spy-planes) 0)
    (town (append land-u* torp-boats patrol-ship destroyer frigate ecarrier) 1)
    (town (marines paratroops field-hq germinator) 0)
    (ruins u* 0)
    (base (append paratroops air-u*) 2)
    (base (marines field-hq) 4)
    (shipyard sea-u* 1)
    (shipyard 
        (marines transports ccruiser battleship lcarrier carrier submarine) 2)
    (shipyard (fighters dive-bombers torp-bombers) 4)
    (germinator (town citadel) 6)
    (engineers (forts base shipyard) 4)
    (engineers landmines 2)
    (torp-boats seamines 2)
    (patrol-ship seamines 1)
)

(table create-range
    ; Default: 0
    (u* (append facility-u* mine-u*) 1)
    (citadel (base shipyard) 2)
    (metropolis town 3)
    (capitol (town citadel base shipyard) (4 2 2 2))
)

(table cp-on-creation
    ; Default: 1
    (u* forts 4)
    (u* mine-u* 2)
)

(table acp-to-build
    ; Default: 0
    (capitol (append town citadel base shipyard land-u* sea-u* air-u*) 3)
    (capitol (field-hq germinator) 6)
    (metropolis (append land-u* sea-u*) 2)
    (metropolis (append town base shipyard air-u*) 4)
    (metropolis germinator 8)
    (metropolis (field-hq spy-planes) 0)
    (citadel (append base shipyard land-u* sea-u* air-u*) 2)
    (citadel field-hq 4)
    (citadel germinator 0)
    (city (append land-u* sea-u*) 2)
    (city (append base shipyard marines paratroops germinator 
            ccruiser battleship lcarrier carrier submarine air-u*) 4)
    (city (paratroops field-hq spy-planes) 0)
    (town (append land-u* torp-boats patrol-ship destroyer frigate ecarrier) 1)
    (town (marines paratroops field-hq germinator) 0)
    (ruins u* 0)
    (base (append paratroops air-u*) 2)
    (base (marines field-hq) 4)
    (shipyard sea-u* 1)
    (shipyard (marines ccruiser battleship lcarrier carrier submarine) 2)
    (shipyard (fighters dive-bombers torp-bombers) 4)
    (germinator (town citadel) 6)
    (engineers (forts base shipyard) 4)
    (engineers landmines 2)
    (torp-boats seamines 2)
    (patrol-ship seamines 1)
)

(table build-range
    ; Default: 0
    (u* (append facility-u* mine-u*) 1)
    (citadel (base shipyard) 2)
    (metropolis town 3)
    (capitol (town citadel base shipyard) (4 2 2 2))
)

(table cp-per-build
    ; Default: 1
    (u* forts 4)
    (u* mine-u* 2)
)

(table acp-to-be-fired-on
    ; Default: 1
)

(table acp-to-attack
    ; Default: 1
    (u* u* 0)
    (land-u* facility-u* 2)
    (land-u* land-u* 2)
    ((aaa artillery germinator engineers) u* 0)
    (engineers (append shipwreck mine-u*) 2)
    (sea-u* sea-u* 2)
    ((fighters efighters dive-bombers bombers) u* 4)
    ((dive-bombers bombers) air-u* 0)
    (torp-bombers sea-u* 4)
)

(table acp-to-defend
    ; Default: 1
)

#|
Do not gie a retreating unit _extra_ ACP just because its terrain is hard 
for it to move in.
(table acp-for-retreat
    ; Default: 0
    (u* land-u* 2)
    (u* armor 4)
    (u* sea-u* 1)
    (u* (frigate cruiser ccruiser battleship carrier) 2)
    (u* air-u* 1)
)
|#

(table hit-chance
    ; Default: 0
    (u* facility-u* 100)
;    (facility-u* facility-u* 0)
    (sea-u* facility-u* 0)
    (torp-bombers facility-u* 0)
    (u* (germinator engineers) 100)
    (facility-u* land-u* 100)
    ((capitol metropolis) air-u* 50)
    ((capitol metropolis) cargo-planes 90)
    ((capitol metropolis) bombers 70)
    ((capitol metropolis) spy-planes 30)
    ((citadel base shipyard) air-u* 60)
    ((citadel base shipyard) cargo-planes 100)
    ((citadel base shipyard) bombers 80)
    ((citadel base shipyard) spy-planes 40)
    (city air-u* 15)
    (town air-u* 5)
    ((city town) cargo-planes (50 20))
    ((city town) bombers (40 10))
    ((city town) spy-planes (0 0))
    (artillery sea-u* 50)
    (artillery submarine 0)
    (sea-u* land-u* 40)
    (sea-u* (infantry paratroops) 30)
    (sea-u* marines 50)
    ((transports torp-boats patrol-ship ecarrier submarine) land-u* 0)
    (land-u* infantry 90)
    (cavalry (infantry paratroops) 100)
    ((fighters efighters) (infantry paratroops) 40)
    (bombers (infantry paratroops) 10)
    (dive-bombers (infantry paratroops) 80)
    (land-u* (mechinf marines) 100)
    ((infantry paratroops) (mechinf marines) 90)
    ((fighters efighters) (mechinf marines) 60)
    (bombers (mechinf marines) 15)
    (dive-bombers (mechinf marines) 90)
    ((infantry paratroops) cavalry 40)
    ((mechinf marines field-hq) cavalry 60)
    ((cavalry armor artillery) cavalry 100)
    ((fighters efighters) cavalry 60)
    (bombers cavalry 15)
    (dive-bombers cavalry 80)
    ((infantry paratroops) armor 20)
    ((mechinf marines field-hq) armor 60)
    ((cavalry armor artillery) armor 100)
    ((fighters efighters) armor 70)
    (bombers armor 15)
    (dive-bombers armor 90)
    (land-u* paratroops 80)
    (land-u* (artillery aaa) 100)
    ((fighters efighters) (artillery aaa) 75)
    (bombers (artillery aaa) 20)
    (dive-bombers (artillery aaa) 100)
    (land-u* field-hq 100)
    ((fighters efighters) field-hq 70)
    (bombers field-hq 15)
    (dive-bombers field-hq 90)
    (sea-u* transports 100)
    (air-u* transports 100)
    (bombers transports 35)
    (sea-u* torp-boats 80)
    ((torp-boats submarine) torp-boats 5)
    ((fighters efighters) torp-boats 80)
    ((dive-bombers torp-bombers) torp-boats 5)
    (sea-u* patrol-ship 80)
    ((torp-boats submarine) patrol-ship 20)
    ((fighters efighters) patrol-ship 70)
    ((dive-bombers torp-bombers) patrol-ship 10)
    (sea-u* destroyer 90)
    ((transports patrol-ship ecarrier) destroyer 40)
    ((torp-boats submarine) destroyer 70)
    ((fighters efighters dive-bombers) destroyer 80)
    (torp-bombers destroyer 90)
    (bombers destroyer 5)
    (sea-u* frigate 90)
    ((transports patrol-ship ecarrier) frigate 30)
    ((torp-boats submarine) frigate 80)
    ((fighters efighters dive-bombers) frigate 80)
    (torp-bombers frigate 90)
    (bombers frigate 5)
    (sea-u* cruiser 100)
    ((transports patrol-ship ecarrier) cruiser 5)
    ((torp-boats submarine) cruiser 90)
    ((destroyer frigate lcarrier carrier) cruiser 80)
    ((fighters efighters dive-bombers torp-bombers) cruiser 100)
    (bombers cruiser 5)
    (sea-u* ccruiser 100)
    ((transports patrol-ship ecarrier) ccruiser 5)
    ((torp-boats submarine) ccruiser 90)
    ((destroyer frigate lcarrier carrier) ccruiser 80)
    ((fighters efighters dive-bombers torp-bombers) ccruiser 100)
    (bombers ccruiser 5)
    (sea-u* battleship 100)
    ((transports patrol-ship ecarrier) battleship 0)
    ((torp-boats submarine) battleship 100)
    ((destroyer frigate lcarrier carrier) battleship 50)
    ((fighters efighters dive-bombers torp-bombers) battleship 100)
    (bombers battleship 10)
    (sea-u* ecarrier 100)
    ((torp-boats submarine) ecarrier 70)
    ((fighters efighters dive-bombers) ecarrier 80)
    (torp-bombers ecarrier 90) 
    (bombers ecarrier 5)
    (sea-u* lcarrier 100)
    ((fighters efighters dive-bombers) lcarrier 90)
    (torp-bombers lcarrier 100)
    (bombers lcarrier 10)
    (sea-u* carrier 100)
    ((fighters efighters dive-bombers torp-bombers) carrier 100)
    (bombers carrier 10)
    (sea-u* submarine 5)
    ((patrol-ship destroyer submarine) submarine 25)
    (air-u* submarine 0)
    (submarine air-u* 0)
    ((infantry paratroops) cargo-planes 5)
    ((mechinf cavalry marines) cargo-planes 15)
    ((aaa field-hq) cargo-planes 100)
    ((transports patrol-ship) cargo-planes 20)
    (torp-boats cargo-planes 5)
    ((destroyer cruiser battleship) cargo-planes 60)
    ((frigate ccruiser ecarrier lcarrier carrier) cargo-planes 80)
    ((fighters efighters) cargo-planes 100)
    ((mechinf cavalry marines) fighters 5)	
    ((aaa field-hq) fighters 75)
    ((transports patrol-ship) fighters 10)
    ((destroyer cruiser battleship) fighters 30)
    ((frigate ccruiser ecarrier lcarrier carrier) fighters 50)
    (fighters fighters 100)
    (efighters fighters 90)
    ((mechinf cavalry marines) efighters 5)	
    ((aaa field-hq) efighters 75)
    ((transports patrol-ship) efighters 10)
    ((destroyer cruiser battleship) efighters 30)
    ((frigate ccruiser ecarrier lcarrier carrier) efighters 50)
    ((fighters efighters) efighters 100)
    ((mechinf cavalry marines) dive-bombers 10)
    ((aaa field-hq) dive-bombers 90)
    ((transports patrol-ship) dive-bombers 15)
    ((destroyer cruiser battleship) dive-bombers 40)
    ((frigate ccruiser ecarrier lcarrier carrier) dive-bombers 60)
    ((fighters efighters) dive-bombers 100)
    ((mechinf cavalry marines) torp-bombers 10)
    ((aaa field-hq) torp-bombers 90)
    ((transports patrol-ship) torp-bombers 15)
    ((destroyer cruiser battleship) torp-bombers 40)
    ((frigate ccruiser ecarrier lcarrier carrier) torp-bombers 60)
    ((fighters efighters) torp-bombers 100)
    ((mechinf cavalry marines) bombers 10)
    ((aaa field-hq) bombers 90)
    ((transports patrol-ship) bombers 15)
    ((destroyer cruiser battleship) bombers 40)
    ((frigate ccruiser ecarrier lcarrier carrier) bombers 60)
    ((fighters efighters) bombers 100)
    (engineers mine-u* 100)
    (air-u* mine-u* 0)
    (ruins u* 0)
    (mine-u* u* 0)
)

(table fire-hit-chance
    ; Default: -1
    ; CRUDE HACK: Disallow capture-by-fire.
    (land-u* facility-u* 0)
    ((aaa artillery) facility-u* 100)
    ; Sea units can bombard coastal and inland facilities.
    (sea-u* facility-u* 100)
    ((transports torp-boats patrol-ship ecarrier submarine) facility-u* 0)
    ; Launch spreads of torps from a distance.
    ((torp-boats torp-bombers) transports 80)
    ((torp-boats torp-bombers) destroyer 20)
    ((torp-boats torp-bombers) (frigate ecarrier) 25)
    ((torp-boats torp-bombers) (cruiser ccruiser) 30)
    ((torp-boats torp-bombers) (battleship lcarrier) 40)
    ((torp-boats torp-bombers) carrier 50)
    ; Special removal of seamines.
    (patrol-ship seamines 75)
)

(table hit-at-max-range-effect
    ; Default: 100%
    ((artillery battleship) u* 75)
)

(table protection
    ; Vulnerability, actually.
    ; Default: 100%
    ; Land units can be covered by buildings, alleyways, etc....
    (facility-u* land-u* 50)
    (facility-u* (infantry paratroops) 10)
    ; Fortifications are very protective, naturally.
    (forts land-u* 20)
    (forts (infantry paratroops) 5)
    ; Sea units cannot manuver well in harbor.
    (facility-u* sea-u* 500)
    ; Air units are sitting ducks on open airfields.
    (facility-u* air-u* 500)
    ; Bases provide armored hangars for air units.
    ((base shipyard) air-u* 0)
    ; Ships in shipyards are quite vulnerable.
    ;   Except subs, which are in reinforced pens.
    (shipyard sea-u* 250)
    (shipyard submarine 10)
    ; HACK: Quell counterattacks from land units aboard transports.
    (transports land-u* 0)
    ; Carriers provide some protection below decks for air units.
    ((ecarrier lcarrier) air-u* 50)
    (carrier air-u* 25)
    ; HACK: Quell counterattacks from land units aboard transports.
    (cargo-planes land-u* 0)
)

(table cellwide-protection-against
    ; Default: 100%
    (aaa-u* air-u* 10)
    (destroyer submarine 10)
)

(table damage
    ; Default: 0
    ; Bombs are nasty no matter what they hit.
    (dive-bombers u* 3d4+2)
    (dive-bombers (citadel base shipyard battleship) 3d4+1)
    (dive-bombers forts 2d4+1)
    (bombers u* 6d8+4)
    (bombers (citadel base shipyard battleship) 6d8+1)
    (bombers forts 5d8+1)
    ; Damage against cities and facilities, except forts.
    ((infantry paratroops) facility-u* 1d2+1)
    ((mechinf marines aaa field-hq) facility-u* 1d4+1)
    (cavalry facility-u* 2d4+2)
    (armor facility-u* 3d4+2)
    (artillery facility-u* 4d4+2)
    ((destroyer carrier) facility-u* 1d4+1)
    (frigate facility-u* 1d6+1)
    (cruiser facility-u* 2d6+2)
    (ccruiser facility-u* 1d8+2)
    (battleship facility-u* 2d8+3)
    ((fighters efighters) facility-u* 1d2)
    ; Damage against forts.
    ((infantry paratroops) forts 1d2)
    ((mechinf marines aaa field-hq) forts 1d4)
    (cavalry forts 1d6+1)
    (armor forts 2d4+1)
    (artillery forts 3d4+1)
    ((destroyer carrier) forts 1d4)
    (frigate forts 1d6)
    (cruiser forts 2d6+1)
    (ccruiser forts 1d8+1)
    (battleship forts 2d6+2)
    ; Units against land units.
    ; Account for resistance by local police and militia.
    (city-u* land-u* 1d2+2)
    (city-u* (mechinf marines artillery field-hq) 1d2+1)
    (city-u* (cavalry armor) 1d2)
    ; Capitols and citadels have fanatical paramilitary defenders.
    ; Bases are defended by military personnel.
    ((capitol citadel base shipyard) land-u* 1d6+3)
    ((capitol citadel base shipyard) (mechinf marines artillery field-hq) 1d6+1)
    ((capitol citadel base shipyard) (cavalry armor) 1d4+1)
    (cavalry land-u* 2d4+2)
    (armor land-u* 3d4+3)
    (artillery land-u* 3d4+3)
    ((destroyer carrier) land-u* 1d2)
    (frigate land-u* 1d3+1)
    (cruiser land-u* 1d6+1)
    (ccruiser land-u* 1d4+1)
    (battleship land-u* 2d4+2)
    (fighters land-u* 1d4+2)
    (efighters land-u* 1d2+1)
    ((infantry paratroops field-hq) (infantry paratroops) 1d2+1)
    ((mechinf marines) (infantry paratroops) 1d4+1)
    (aaa (infantry paratroops) 1d2)
    ((fighters efighters) (infantry paratroops) 1d2)
    ((infantry paratroops aaa field-hq) (mechinf marines field-hq) 1d2)
    ((mechinf marines) (mechinf marines field-hq) 1d2+1)
    ((infantry paratroops aaa field-hq) cavalry 1d2)
    ((mechinf marines) cavalry 1d2+1)
    (cavalry cavalry 2d4+1)
    ((armor artillery) cavalry 3d4+2)
    ((mechinf marines) armor 1d2)
    (cavalry armor 1d6+1)
    ((armor artillery) armor 1d10+1)
    ((infantry paratroops aaa field-hq) (artillery aaa) 1d4+1)
    ((mechinf marines) (artillery aaa) 1d6+2)
    ((infantry paratroops aaa field-hq) (germinator engineers) 1d4+1)
    ((mechinf marines) engineers 2d4+2)
    ((destroyer carrier) transports 1d3+1)
    ; Units against sea units.
    (artillery sea-u* 1d3+1)
    (artillery battleship 1d3)
    ((transports patrol-ship ecarrier) sea-u* 1d2)
    ((transports patrol-ship ecarrier) (cruiser ccruiser battleship) 0)
    (torp-boats sea-u* 3d6+4)
    (torp-boats battleship 3d6+2)
    ((destroyer carrier) sea-u* 1d4+1)
    ((destroyer carrier) (cruiser ccruiser) 1d4)
    ((destroyer carrier) battleship 1d2)
    (frigate sea-u* 1d6+1)
    (frigate (cruiser ccruiser) 1d4+1)
    (frigate battleship 1d4)
    (cruiser sea-u* 2d6+2)
    (cruiser (cruiser ccruiser) 2d6+1)
    (cruiser battleship 1d8+1)
    (ccruiser sea-u* 1d8+2)
    (ccruiser (cruiser ccruiser) 1d8+1)
    (ccruiser battleship 1d6+1)
    (battleship sea-u* 4d4+3)
    (battleship (cruiser ccruiser) 4d4+2)
    (battleship battleship 2d6+2)
    (lcarrier sea-u* 1d2+1)
    (lcarrier (cruiser ccruiser) 1d2)
    (lcarrier battleship 0)
    (submarine sea-u* 4d8+4)
    (submarine battleship 4d8+2)
    ((fighters efighters) sea-u* 1d2)
    ((fighters efighters) (cruiser ccruiser battleship) 0)
    (torp-bombers sea-u* 1d10+4)
    (torp-bombers battleship 1d10+2)
    ; Units against air units.
    ; Planes get standard damage from units with weak/normal AA capabilities.
    (u* air-u* 1d2)
    (u* cargo-planes 1d4+1)
    ; Planes get extra damage from units with serious AA weaponry.
    (aaa-u* air-u* 1d4+1)
    (aaa-u* cargo-planes 1d8+2)
    ((fighters efighters) cargo-planes 2d6+3)
    ((fighters efighters) (fighters efighters) 1d4+1)
    ((fighters efighters) (dive-bombers torp-bombers) 1d8+2)
    ; All units will damage mines.
    (u* mine-u* 1)
    (engineers mine-u* 2)
    (patrol-ship seamines 2)
    (ruins u* 0)
    (mine-u* u* 0)
)

(table hp-min
    ; Default: 0
    (u* ruins 10)
    (u* shipwreck 4)
    (engineers shipwreck 0)
    (u* mine-u* 6)
    (engineers mine-u* 0)
    (patrol-ship seamines 0)
)

#|
The retreat-chance table is more useful in simultaneous games and can be 
annoying in sequential ones, because an attacking unit will always miss a 
unit that is retreating, and if the attacker has to hunt the defender and 
the two have similar quantities of ACP, then this is not productive.
In a simul game, attacking can at least waste the defender's ACP to the 
immediate disadvantage of the defending player, and retreating can keep 
the defender alive long enough to let the defending player respond.
(table retreat-chance
    ; Default: 0
    ((cavalry armor aaa artillery) infantry 100)
    ((cavalry armor aaa artillery dive-bombers) mechinf 100)
    ((artillery dive-bombers bombers) cavalry 100)
    ((dive-bombers bombers) armor 100)
    ((armor artillery dive-bombers) marines 50)
    ((cavalry armor aaa artillery) paratroops 100)
    (land-u* (aaa artillery field-hq) 100)
    ((dive-bombers bombers) (aaa artillery field-hq) 100)
    (u* (germinator engineers) 100)
    (u* transports 100)
    (sea-u* torp-boats 100)
    ((torp-boats submarine) torp-boats 0)
    (sea-u* patrol-ship 100)
    ((torp-boats patrol-ship submarine) patrol-ship 0)
    (sea-u* destroyer 100)
    ((torp-boats patrol-ship destroyer submarine) destroyer 0)
    ((cruiser ccruiser battleship) frigate 100)
    ((torp-boats battleship submarine) cruiser 100)
    (sea-u* ccruiser 100)
    (sea-u* carrier-u* 100)
    ((patrol-ship destroyer) submarine 100)
    ((aaa field-hq frigate ccruiser) air-u* 100)
    ((fighters efighters) (cargo-planes bombers) 25)
    ((fighters efighters) (dive-bombers torp-bombers) 50)
    ((fighters efighters) spy-planes 90)
    (air-u* (fighters efighters) 0)
    (facility-u* u* 0)
    ((capitol metropolis citadel city) land-u* 100)
    ((capitol metropolis citadel) air-u* 25)
    (city (cavalry armor) (50 30))
    ((germinator engineers) u* 0)
    ((append transports carrier-u*) u* 0)
    ((cargo-planes spy-planes) u* 0)
    (mine-u* u* 0)
)
|#

(table counterattack
    ; Default: 100%
)

(table acp-to-capture
    ; Default: 0
)

(table bridge
    ; Default: false
    (facility-u* land-u* true)
)

(table capture-chance
    ; Default: 0
    ; Paratroops, stormtroops, and special-ops are excellent at storming.
    ((infantry field-hq) ruins 60)
    ((mechinf marines paratroops) ruins 80)
    ((cavalry armor) ruins 100)
    ((infantry field-hq) (town shipyard) 40)
    ((mechinf marines paratroops) (town shipyard) 60)
    ((cavalry armor) (town shipyard) 100)
    ((infantry field-hq) (city base) 15)
    ((mechinf marines paratroops) (city base) 25)
    (cavalry (city base) 50)
    (armor (city base) 60)
    ((cavalry armor) metropolis (5 15))
    (armor (citadel capitol) 5)
    ((infantry paratroops) forts (10 15))
    ((mechinf marines) forts 20)
    (engineers shipwreck 100)
)

(table independent-capture-chance
    ; Default: 0%
    (land-u* ruins 100)
    ((infantry field-hq) town 70)
    ((mechinf marines paratroops) town 85)
    ((cavalry armor) town 100)
    ((infantry field-hq) city 40)
    ((mechinf marines paratroops) city 50)
    ((cavalry armor) city (90 100))
    ((cavalry armor) metropolis (40 50))
)

(table scuttle-chance
    ; Default: 0%
    (land-u* u* 100)
    (sea-u* u* 100)
    (air-u* u* 100)
)

(table occupant-escape-chance
    ; Default: 0%
    (cavalry u* 100)
    (armor u* 100)
    ((infantry artillery aaa field-hq engineers) ruins 30)
    ((mechinf marines paratroops) ruins 45)
    ; Aircraft are not supposed to be able land in ruins....
    ((infantry artillery aaa field-hq engineers) (town base) 50)
    ((mechinf marines paratroops) (town base) 65)
    ((infantry artillery aaa field-hq engineers) city 70)
    ((mechinf marines paratroops) city 80)
    ; Citadel resistance is very stiff, so escape chances are high.
    ((append land-u* air-u*) citadel 100)
    ((infantry artillery aaa field-hq engineers) metropolis 90)
    ((mechinf marines paratroops) metropolis 100)
    (air-u* metropolis 100)
    (cargo-planes metropolis 90)
    (land-u* forts 80)
    (air-u* (forts base) 70)
    (cargo-planes (forts base) 50)
    (bombers (forts base) 60)
    (germinator u* 0)
    ; If the Capitol is captured, then it's all over....
    (u* capitol 0)
)

(table occupant-combat
    ; Default: 100
    ; Air and sea units are largely helpless as occupants.
    (u* facility-u* 0)
    ; By contrast, land units get entrenched in facilities.
    (land-u* facility-u* 150)
    ; Fanaticism and fortifications.
    (land-u* (capitol citadel forts) 250)
    ; Ruins do not offer much cover.
    (land-u* ruins 100)
    ; Ships lack manueverability.
    (sea-u* shipyard 20)
    (submarine shipyard 0)
    ; Units cannot do much fighting when they are essentially cargo.
    (land-u* transports 0)
    (air-u* carrier-u* 0)
    (land-u* cargo-planes 0)
    ; Help Screen Aesthetics
    (facility-u* u* 0)
    (mine-u* u* 0)
)

(table hp-to-garrison
    ; Default: 0
    ; Some units are assumed to have military police with them.
    ((cavalry armor) (town shipyard) 2)
    ((marines paratroops) (town shipyard) 2)
    ((infantry mechinf) (city base) 4)
    ((cavalry armor marines paratroops) (city base) 6)
    (field-hq (city base) 8)
    ((cavalry armor) metropolis 12)
    (armor (citadel capitol) 16)
    (land-u* forts 1)
)

(table countercapture
    ; Default: 100
)

(table see-others-if-captured
    ; Default: 0
    (capitol u* 100)
    (metropolis facility-u* 90)
    (citadel u* 30)
    (citadel facility-u* 100)
    (citadel mine-u* 20)
    (city facility-u* 40)
    (forts (forts base) 5)
    (forts landmines 5)
    (base u* 10)
    (base land-u* 20)
    (base air-u* 25)
    (shipyard sea-u* 20)
    (shipyard seamines 10)
)

; Damage effect extrapolates from detonation-damage-adjacent
(table detonation-unit-range
    ; Default: 0
)

(table detonation-damage-at
    ; Default: 0
    (dive-bombers facility-u* 5d5+10)
    (dive-bombers forts 3d5+5)
    (dive-bombers (append land-u* sea-u*) 3d5+10)
    (torp-bombers sea-u* 4d5+10)
    (torp-bombers battleship 4d5+5)
    (landmines land-u* 1d3+1)
    (seamines sea-u* 1d3+1)
    (mine-u* engineers 0)
)

(table detonation-damage-adjacent
    ; Default: 0
)

(table detonate-on-hit
    ; Default: 0
    (mine-u* u* 100)
)

(table detonate-on-approach-range
    ; Default: -1
    (landmines land-u* 0)
    (seamines sea-u* 0)
)

(table acp-to-repair
    ; Default: 0
    ; NOTE: All repairs are automatic. No explicit action allowed.
)

(table hp-per-repair
    ; Default: 0
    ; NOTE: All repairs are automatic. No explicit action allowed.
)

(table auto-repair
    ; Default: 0
    (city-u* (base shipyard) 1.00)
    ((append city-u* base) land-u* 1.00)
    ((append city-u* base) (cavalry armor) 3.00)
    (shipyard (marines engineers) 1.00)
    ((append city-u* shipyard) sea-u* 2.00)
    ((append city-u* shipyard) 
        (cruiser ccruiser battleship lcarrier carrier submarine) 4.00)
    ((append city-u* base shipyard) air-u* 2.00)
    ((append city-u* base shipyard) cargo-planes 1.00)
    (town (append air-u* sea-u*) 0)
    (engineers forts 5.00)
    (engineers (base shipyard) 1.00)
    (engineers landmines 6.0)
    (torp-boats seamines 6.0)
    (patrol-ship seamines 6.0)
    (ruins u* 0)
)

(table auto-repair-range
    ; Default: 0
;    (facility-u* (append land-u* sea-u* air-u*) -1)
    ((append city-u* engineers) (base shipyard) 1)
    (engineers landmines 1)
)

(table see-chance-at
    ; Default: 100
    (u* submarine 0)
    (u* spy-planes 30)
    (u* mine-u* 0)
    (land-u* landmines 100)
    (sea-u* seamines 100)
    (sea-u* submarine 10)
    ((patrol-ship destroyer) submarine 75)
    (air-u* spy-planes 60)
    (ruins u* 0)
)

(table see-chance-adjacent
    ; Default: 100
    (u* u* 0)
    (u* air-u* 70)
    (u* cargo-planes 100)
    (u* spy-planes 0)
    (city-u* u* 100)
    (ruins u* 0)
    (u* city-u* 100)
    (u* ruins 50)
    (land-u* forts 50)
    (air-u* forts 90)
    (u* (base shipyard) 100)
    (land-u* land-u* 50)
    (cavalry land-u* 100)
    (air-u* land-u* 70)
    (land-u* (infantry paratroops) 30)
    (air-u* (infantry paratroops) 50)
    (cavalry (infantry paratroops) 80)
    (land-u* (cavalry armor engineers) 70)
    (air-u* (cavalry armor engineers) 90)
    (sea-u* marines 10)
    (air-u* sea-u* 90)
    (air-u* submarine 0)
    ((append land-u* sea-u*) transports 50)
    ((append cruiser ccruiser battleship carrier-u*) transports 100)
    (air-u* transports 100)
    ((append land-u* sea-u*) (torp-boats patrol-ship) 5)
    (air-u* torp-boats 70)
    (air-u* patrol-ship 60)
    ((append land-u* sea-u*) (destroyer frigate) 10)
    (air-u* (destroyer frigate) 80)
    ((append land-u* sea-u*) (cruiser ccruiser ecarrier) 15)
    ((append land-u* sea-u*) (battleship lcarrier) 20)
    ((append land-u* sea-u*) carrier 25)
    ((append cruiser ccruiser battleship carrier-u*) sea-u* 50)
    ((append cruiser ccruiser battleship carrier-u*) 
        (cruiser ccruiser battleship lcarrier carrier) 80) 
    ((append cruiser ccruiser battleship carrier-u*) submarine 0)
    (air-u* (lcarrier carrier) 100)
    (aaa air-u* 100)
    ((append ccruiser carrier-u*) air-u* 100)
    (air-u* air-u* 70)
    (air-u* cargo-planes 100)
    (air-u* spy-planes 20)
    (spy-planes u* 100)
    (spy-planes submarine 0)
    (spy-planes spy-planes 60)
    (u* mine-u* 0)
)

(table see-chance
    ; Default: 100
    (u* u* 0)
    (u* (capitol metropolis) 30)
    (cavalry land-u* 70)
    (cavalry (infantry paratroops) 40)
    (cavalry (cavalry armor engineers) 90)
    (spy-planes (append land-u* sea-u*) 90)
    (spy-planes (infantry paratroops) 60)
    (spy-planes (cavalry armor engineers) 100)
    (spy-planes submarine 0)
    (spy-planes air-u* 100)
    (spy-planes spy-planes 10)
)

(table occupant-vision
    ; Default is assumed 100.
    (land-u* (transports cargo-planes) 0)
    (air-u* facility-u* 0)
    (air-u* carrier-u* 0)
)

(table track-chance
    ; Default: 0 ppdk
    (facility-u* u* 10000)
    (facility-u* submarine 0)
    (u* facility-u* 10000)
    (land-u* land-u* 10000)
    (air-u* land-u* 10000)
    (land-u* paratroops 8000)
    (air-u* paratroops 8000)
    (u* sea-u* 10000)
    (u* air-u* 10000)
    (u* spy-planes 8000)
    (u* mine-u* 10000)
    (spy-planes u* 10000)
    ((append land-u* air-u*) submarine 0)
    (sea-u* submarine 5000)
)

(table acp-occupant-effect
    ; Default: 100%
)

(table size-limit-without-occupant
    ; Default: TABHI
)

#|
(table can-change-type-to
    ; Default: false
    (town city true)
    (city metropolis true)
)

(table acp-to-change-type
    ; Default: 0
    (town city 1)
    (city metropolis 1)
)
|#

(table size-to-change-type
    ; Default: 0
    (town city 60)
    (city metropolis 180)
)

(table cxp-to-change-type
    ; Default: 0
)

(table occupants-to-change-type
    ; Default: 0
)

(table turn-to-change-type
    ; Default: 0
)

(set action-notices '(
    ((destroy u* facility-u*) (actor " demolishes " actee "!"))
    ((destroy u* land-u*) (actor " breaks and disperses " actee "!"))
    ((destroy u* sea-u*) (actor " sinks " actee "!"))
    ((destroy u* air-u*) (actor " blasts " actee " out of the sky!"))
    ((destroy u* mine-u*) (actor " totally clears " actee "."))
    ((disband (ruins shipwreck) self done) (actor " is cleared out."))
    ((disband mine-u* self done) (actor " is totally cleared."))
    (
        (capture paratroops facility-u*)
        (actor " storms and captures " actee "!")
    )
    (
        (liberate paratroops facility-u*)
        (actor " storms and liberates " actee "!")
    )
    (
        (capture (cavalry armor) facility-u*)
        (actor " overwhelms and captures " actee "!")
    )
    (
        (hit (infantry mechinf marines paratroops) facility-u*)
        (actor " shoots up " actee ".")
    )
    (
        (hit (cavalry armor artillery aaa) facility-u*)
        (actor " volleys fire upon " actee ".")
    )
    (
        (hit (dive-bombers bombers) facility-u*)
        (actor " rains bombs upon " actee ".")
    )
    ((hit (fighters efighters) land-u*) (actor " strafes " actee "."))
    ((hit (dive-bombers bombers) land-u*) (actor " bombs " actee "."))
    ((hit (torp-boats torp-bombers) sea-u*) (actor " torpedoes " actee "."))
    ((hit (dive-bombers bombers) sea-u*) (actor " bombs " actee "."))
))

(set event-notices '(
    ((unit-starved infantry) (0 " is disbanded by illness and starvation!"))
    ((unit-starved mechinf) (0 " is disbanded by illness and starvation!"))
    ((unit-starved cavalry) (0 " is disbanded by illness and starvation!"))
    ((unit-starved armor) (0 " is disbanded by illness and starvation!"))
    ((unit-starved marines) (0 " is disbanded by illness and starvation!"))
    ((unit-starved paratroops) (0 " is disbanded by illness and starvation!"))
    ((unit-starved aaa) (0 " is disbanded by illness and starvation!"))
    ((unit-starved artillery) (0 " is disbanded by illness and starvation!"))
    ((unit-starved field-hq) (0 " is disbanded by illness and starvation!"))
    ((unit-starved germinator) (0 " is disbanded by illness and starvation!"))
    ((unit-starved engineers) (0 " is disbanded by illness and starvation!"))
    ((unit-starved cargo-planes) (0 " runs out of fuel and crashes!"))
    ((unit-starved fighters) (0 " runs out of fuel and crashes!"))
    ((unit-starved efighters) (0 " runs out of fuel and crashes!"))
    ((unit-starved dive-bombers) (0 " runs out of fuel and crashes!"))
    ((unit-starved torp-bombers) (0 " runs out of fuel and crashes!"))
    ((unit-starved bombers) (0 " runs out of fuel and crashes!"))
    ((unit-starved spy-planes) (0 " runs out of fuel and crashes!"))
))

(set event-narratives '(
    ((unit-starved infantry) (0 " was disbanded by illness and starvation!"))
    ((unit-starved mechinf) (0 " was disbanded by illness and starvation!"))
    ((unit-starved cavalry) (0 " was disbanded by illness and starvation!"))
    ((unit-starved armor) (0 " was disbanded by illness and starvation!"))
    ((unit-starved marines) (0 " was disbanded by illness and starvation!"))
    ((unit-starved paratroops) (0 " was disbanded by illness and starvation!"))
    ((unit-starved aaa) (0 " was disbanded by illness and starvation!"))
    ((unit-starved artillery) (0 " was disbanded by illness and starvation!"))
    ((unit-starved field-hq) (0 " was disbanded by illness and starvation!"))
    ((unit-starved germinator) (0 " was disbanded by illness and starvation!"))
    ((unit-starved engineers) (0 " was disbanded by illness and starvation!"))
    ((unit-starved cargo-planes) (0 " ran out of fuel and crashed!"))
    ((unit-starved fighters) (0 " ran out of fuel and crashed!"))
    ((unit-starved efighters) (0 " ran out of fuel and crashed!"))
    ((unit-starved dive-bombers) (0 " ran out of fuel and crashed!"))
    ((unit-starved torp-bombers) (0 " ran out of fuel and crashed!"))
    ((unit-starved bombers) (0 " ran out of fuel and crashed!"))
    ((unit-starved spy-planes) (0 " ran out of fuel and crashed!"))
))
